// Fig. 4.16: fig04_16_2.cpp
// This program sorts an array's values into ascending order.
#include <iostream>

using std::cout;
using std::cin;
using std::endl;

#include <iomanip>

using std::setw;
void swap(int *,int *);

int main()
{
   int N;  // size of array a
   int *a;
   int i;  // temporary location used to swap array elements

   cout << "give the array size\n";
   cin >> N;
   a=(int *)malloc(sizeof(int)*N);

   for (i=0; i<N; i++ )
   {
	   cout << "give me element\n";
	   cin >> a[i];
   }

   // output original array
   for ( i = 0; i < N; i++ )
      cout << setw( 4 ) << a[ i ];

   // bubble sort
   // loop to control number of passes
   for ( int pass = 0; pass < N - 1; pass++ )

      // loop to control number of comparisons per pass
      for ( int j = 0; j < N - 1; j++ )  

         // compare side-by-side elements and swap them if 
         // first element is greater than second element
         if ( a[ j ] > a[ j + 1 ] ) swap(&a[j],&a[j+1]);    

   cout << "\nData items in ascending order\n";

   // output sorted array
   for ( int k = 0; k < N; k++ )
      cout << setw( 4 ) << a[ k ];

   cout << endl;

   return 0;  // indicates successful termination

} // end main

void swap(int *element1,int *element2)
{
	int hold=*element1;
	*element1=*element2;
	*element2=*element1;
}

/**************************************************************************
 * (C) Copyright 1992-2003 by Deitel & Associates, Inc. and Prentice      *
 * Hall. All Rights Reserved.                                             *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/
